Package ru.bitel.bgbilling.modules.npay.common.service

# Interface NPayService

public interface NPayService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accountClear(Period period, List<Integer> contractIds, List<Integer> contractLabelIds, int serviceSet)`
  `List<ru.bitel.bgbilling.common.model.KeyValue>`
  `configValueList()`
  Параметры конфигурации
  `void`
  `configValueUpdate(List<ru.bitel.bgbilling.common.model.KeyValue> keyValues)`
  Сохранение параметров конфигурации
  `BigDecimal`
  `getAmountForUnlock(int contractId)`
  Для заблокированных дебетовых договоров возвращает сумму платежа необходимого для разблокировки.
  `BigDecimal`
  `precalculateAccount(int contractId, int serviceSet, Date dateFrom, Date dateTo, int status)`
  Вычисление будущей наработки для определения рекомендуемого платежа.
  `void`
  `recalculatePay(Period period, List<Integer> contractIds, List<Integer> contractLabelIds, int serviceSet, boolean detail, String comment, String email)`
  `List<ServiceObject>`
  `serviceObjectChangeLog(int contractId, int serviceObjectId)`
  `void`
  `serviceObjectDelete(int contractId, int serviceId)`
  `ServiceObject`
  `serviceObjectGet(int id)`
  `List<ServiceObject>`
  `serviceObjectList(int contractId, int objectId, int entityModuleId, int entityId, boolean actualItemsOnly, Date actualItemsDate)`
  `void`
  `serviceObjectUpdate(int contractId, ServiceObject serviceObject)`
  `Collection<String>`
  `serviceSetGet(int parseInt)`
  `List<IdTitle>`
  `serviceSetList()`
  `Boolean[][]`
  `serviceStatusMatrixGet(List<Integer> serviceIds, List<Integer> statusIds, boolean replaceDefaultToValue)`
  `void`
  `serviceStatusMatrixUpdate(List<Integer> serviceIds, List<Integer> statusIds, Boolean[][] values)`

- ## Method Details

  - ### precalculateAccount

    BigDecimal precalculateAccount(int contractId, int serviceSet, Date dateFrom, Date dateTo, int status) throws Exception
    Вычисление будущей наработки для определения рекомендуемого платежа.
    Parameters:
      `contractId` - ID договора.
      `serviceSet` - набор услуг модуля.
      `dateFrom` - дата начала активности договора (должна быть в одном месяце с dateTo).
      `dateTo` - дата окончания активности договора (должна быть в одном месяце с dateFrom).
    Returns:
    Throws:
      `BGException`
      `BGMessageException`
      `BGIllegalAccessException`
      `Exception`

  - ### getAmountForUnlock

    BigDecimal getAmountForUnlock(int contractId) throws Exception
    Для заблокированных дебетовых договоров возвращает сумму платежа необходимого для разблокировки.
    Parameters:
      `contractId` - ID договора.
    Returns:
    Throws:
      `BGException`
      `BGMessageException`
      `BGIllegalAccessException`
      `Exception`

  - ### serviceObjectList

    List<ServiceObject> serviceObjectList(int contractId, int objectId, int entityModuleId, int entityId, boolean actualItemsOnly, Date actualItemsDate) throws Exception
    Throws:
      `Exception`

  - ### serviceObjectGet

    ServiceObject serviceObjectGet(int id) throws Exception
    Throws:
      `Exception`

  - ### serviceObjectUpdate

    void serviceObjectUpdate(int contractId, ServiceObject serviceObject) throws Exception
    Throws:
      `Exception`

  - ### serviceObjectChangeLog

    List<ServiceObject> serviceObjectChangeLog(int contractId, int serviceObjectId) throws Exception
    Throws:
      `Exception`

  - ### serviceObjectDelete

    void serviceObjectDelete(int contractId, int serviceId) throws Exception
    Throws:
      `Exception`

  - ### serviceStatusMatrixGet

    Boolean[][] serviceStatusMatrixGet(List<Integer> serviceIds, List<Integer> statusIds, boolean replaceDefaultToValue) throws Exception
    Throws:
      `Exception`

  - ### serviceStatusMatrixUpdate

    void serviceStatusMatrixUpdate(List<Integer> serviceIds, List<Integer> statusIds, Boolean[][] values) throws Exception
    Throws:
      `Exception`

  - ### serviceSetGet

    Collection<String> serviceSetGet(int parseInt) throws Exception
    Throws:
      `Exception`

  - ### serviceSetList

    List<IdTitle> serviceSetList() throws Exception
    Throws:
      `Exception`

  - ### configValueList

    List<ru.bitel.bgbilling.common.model.KeyValue> configValueList() throws Exception
    Параметры конфигурации
    Returns:
    Throws:
      `BGException`
      `BGMessageException`
      `Exception`

  - ### configValueUpdate

    void configValueUpdate(List<ru.bitel.bgbilling.common.model.KeyValue> keyValues) throws Exception
    Сохранение параметров конфигурации
    Parameters:
      `keyValues` -
    Throws:
      `BGException`
      `BGMessageException`
      `Exception`

  - ### accountClear

    void accountClear(Period period, List<Integer> contractIds, List<Integer> contractLabelIds, int serviceSet) throws Exception
    Throws:
      `Exception`

  - ### recalculatePay

    void recalculatePay(Period period, List<Integer> contractIds, List<Integer> contractLabelIds, int serviceSet, boolean detail, String comment, String email) throws Exception
    Throws:
      `Exception`